VirtualBox

source: vbox/trunk/configure@ 65884

Last change on this file since 65884 was 65884, checked in by vboxsync, 8 years ago

configure: Linux > 4.8.0 => Linux >= 4.9.0

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 83.7 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2016 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, grep, sed to work)
23PATH="/usr/xpg4/bin:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr '[:upper:]' '[:lower:]'`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 netbsd)
55 ;;
56 sunos)
57 OS='solaris'
58 ;;
59 haiku)
60 ;;
61 *)
62 echo "Cannot determine OS!"
63 exit 1
64 ;;
65esac
66
67#
68# Defaults
69#
70OSE=1
71ODIR="`pwd`/"
72ODIR_OVERRIDE=0
73OUT_PATH=""
74OUT_PATH_OVERRIDE=0
75SETUP_WINE=
76ONLY_ADDITIONS=0
77TARGET_MACHINE=""
78TARGET_CPU=""
79WITH_XPCOM=1
80WITH_PYTHON=1
81WITH_JAVA=1
82WITH_VMMRAW=1
83WITH_LIBIDL=1
84WITH_GSOAP=0
85WITH_QT4=0
86WITH_QT5=1
87WITH_SDL=1
88WITH_SDL_TTF=1
89WITH_X11=1
90WITH_ALSA=1
91WITH_PULSE=1
92WITH_DBUS=1
93WITH_DEVMAPPER=1
94WITH_KMODS=1
95WITH_OPENGL=1
96WITH_HARDENING=1
97WITH_UDPTUNNEL=1
98WITH_VDE=0
99WITH_VNC=0
100WITH_EXTPACK=1
101WITH_DOCS=1
102WITH_LIBVPX=1
103BUILD_LIBXML2=
104BUILD_LIBCURL=
105BUILD_LIBSSL=
106BUILD_LIBVPX=
107PASSIVE_MESA=0
108CC="gcc"
109CC32=""
110CC64=""
111CXX="g++"
112CXX32=""
113CXX64=""
114YASM="yasm"
115IASL="iasl"
116XSLTPROC="xsltproc"
117GENISOIMAGE="genisoimage"
118MKISOFS="mkisofs"
119INCCRYPTO=""
120LIBCRYPTO="-lssl -lcrypto"
121LIBPTHREAD="-lpthread"
122LIBCAP="-lcap"
123GSOAP=""
124GSOAP_IMPORT=""
125INCX11="/usr/local/include"
126LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
127LIBXCURSOR="-lXcursor"
128LIBXMU="-lXmu"
129LIBXINERAMA="-lXinerama"
130LIBXRANDR="-lXrandr"
131MAKESELF="makeself"
132MESA="-lGL"
133INCZ=""
134LIBZ="-lz"
135INCVNCSERVER=""
136LIBVNCSERVER="-lvncserver"
137INCDEVMAPPER=""
138LIBDEVMAPPER="-ldevmapper"
139CXX_FLAGS=""
140if [ "$OS" = "freebsd" ]; then
141 INCCURL="-I/usr/local/include"
142 LIBCURL="-L/usr/local/lib -lcurl"
143 INCPULSE="-I/usr/local/include"
144 LIBPULSE="-L/usr/local/lib"
145 INCPNG="-I/usr/local/include"
146 LIBPNG="-L/usr/local/lib -lpng"
147else
148 INCCURL=""
149 LIBCURL="-lcurl"
150 INCPNG=""
151 LIBPNG="-lpng"
152fi
153INCVPX=""
154LIBVPX="-lvpx"
155PKGCONFIG="`which_wrapper pkg-config`"
156PYTHONDIR="/usr /usr/local"
157QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
158QT4DIR_PKGCONFIG=1
159QT5DIR="/usr/lib/qt5 /usr/share/qt5 /usr/lib64/qt5 /usr /usr/local"
160QT5DIR_PKGCONFIG=1
161KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
162DEVDIR="`cd \`dirname $0\`; pwd`/tools"
163if [ -d "/lib/modules/`uname -r`/build" ]; then
164 LINUX="/lib/modules/`uname -r`/build"
165elif [ "`echo /lib/modules/*`" != "/lib/modules/*" ]; then
166 # Get the most recent kernel headers if none match the current kernel.
167 for i in /lib/modules/*; do
168 if [ -r "$i/build" ]; then
169 LINUX="$i/build"
170 fi
171 done
172fi
173if [ -z "$LINUX" ]; then
174 LINUX="/usr/src/linux"
175fi
176KCHMVIEWER="kchmviewer"
177LOG="configure.log"
178CNF="AutoConfig.kmk"
179ENV="env.sh"
180BUILD_TYPE="release"
181# the restricting tool is ar (mri mode).
182INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
183
184if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
185 echo "Error: VBox base path contains invalid characters!"
186 exit 1
187fi
188
189# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
190if [ "$OS" = "darwin" ]; then
191 ECHO_N="/bin/echo -n"
192elif [ "$OS" = "solaris" ]; then
193 # Solaris 11 /bin/sh has a builtin echo that could grok -n if there is
194 # /usr/ucb/echo the first echo executable in the path, but the /usr/ucb
195 # tools are no longer installed by default.
196 ECHO_N="/usr/gnu/bin/echo -n"
197else
198 ECHO_N="echo -n"
199fi
200
201
202cleanup()
203{
204 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
205}
206
207fail()
208{
209 if [ -z "$nofatal" -o "x$1" != "x" ]; then
210 cleanup
211 rm -f $ENV
212 echo "Check $LOG for details"
213 exit 1
214 fi
215}
216
217log()
218{
219 echo "$1"
220 echo "$1" >> $LOG
221}
222
223log_success()
224{
225 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
226 echo "OK."
227 echo "$1" >> $LOG
228 echo >> $LOG
229 echo >> $LOG
230}
231
232log_failure()
233{
234 echo
235 echo " ** $1!"
236 echo "** $1!" >> $LOG
237 echo >> $LOG
238}
239
240cnf_append()
241{
242 printf "%-30s := %s\n" "$1" "$2" >> $CNF
243}
244
245strip_l()
246{
247 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
248}
249
250strip_L()
251{
252 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
253}
254
255strip_I()
256{
257 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
258}
259
260prefix_I()
261{
262 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
263}
264
265check_avail()
266{
267 if [ -z "$1" ]; then
268 log_failure "$2 is empty"
269 fail $3
270 return 1
271 elif which_wrapper $1 > /dev/null; then
272 return 0
273 else
274 log_failure "$1 (variable $2) not found"
275 fail $3
276 return 1
277 fi
278}
279
280
281# Prepare a test
282test_header()
283{
284 echo "***** Checking $1 *****" >> $LOG
285 $ECHO_N "Checking for $1: "
286}
287
288
289# Compile a test
290# $1 compile flags/libs
291# $2 library name
292# $3 package name
293# $4 if this argument is 'nofatal', don't abort
294test_compile()
295{
296 echo "compiling the following source file:" >> $LOG
297 cat $ODIR.tmp_src.cc >> $LOG
298 echo "using the following command line:" >> $LOG
299 echo "$CXX $CXX_FLAGS -fPIC -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
300 $CXX $CXX_FLAGS -fPIC -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
301 if [ $? -ne 0 ]; then
302 if [ -z "$4" ]; then
303 echo
304 echo " $2 not found at $1 or $3 headers not found"
305 echo " Check the file $LOG for detailed error information."
306 fail
307 else
308 echo >> $LOG
309 echo >> $LOG
310 fi
311 return 1
312 fi
313 return 0
314}
315
316
317# Execute a compiled test binary
318test_execute()
319{
320 echo "executing the binary" >> $LOG
321 $ODIR.tmp_out > $ODIR.test_execute.log
322 rc=$?
323 cat $ODIR.test_execute.log | tee -a $LOG
324 if [ $rc -ne 0 ]; then
325 fail $1
326 return 1
327 fi
328 echo >> $LOG
329 echo >> $LOG
330 return 0
331}
332
333
334# Execute a compiled test binary
335test_execute_path()
336{
337 ## LD_LIBRARY_PATH to set.
338 local_path="${1}"
339 ## Set this to non-empty to make this test non-fatal.
340 local_nofail="${2}"
341 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
342 LD_LIBRARY_PATH="${local_path}" $ODIR.tmp_out > $ODIR.test_execute.log
343 rc=$?
344 cat $ODIR.test_execute.log | tee -a $LOG
345 if [ $rc -ne 0 ]; then
346 test -z "${local_nofail}" && fail
347 echo >> $LOG
348 echo >> $LOG
349 return 1
350 fi
351 echo >> $LOG
352 echo >> $LOG
353 return 0
354}
355
356
357#
358# Check for OS, MACHINE, CPU
359#
360check_environment()
361{
362 test_header environment
363 BUILD_CPU=`uname -m`
364 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
365 case "$BUILD_CPU" in
366 i[3456789]86|x86|i86pc|BePC)
367 BUILD_MACHINE='x86'
368 LIB='lib'
369 ;;
370 x86_64|amd64)
371 BUILD_MACHINE='amd64'
372 BUILD_CPU='k8'
373 if [ "$OS" != "solaris" ]; then
374 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
375 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
376 LIB='lib64'
377 else
378 # Solaris doesn't seem to subscribe to fhs, libs are usually in
379 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
380 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
381 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
382 # have to make sure the */bin/amd64 dirs are searched before the */bin
383 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
384 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
385 echo "old PATH: $PATH" >> $LOG
386 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
387 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
388 export PATH
389 echo "new PATH: $PATH" >> $LOG
390 LIB='lib/64'
391 fi
392 ;;
393 *)
394 log_failure "Cannot determine system"
395 exit 1
396 ;;
397 esac
398 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
399 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
400 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
401 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
402
403 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
404 echo "export BUILD_PLATFORM" >> $ENV
405 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
406 echo "export BUILD_PLATFORM_ARCH" >> $ENV
407 echo "BUILD_TARGET=\"$OS\"" >> $ENV
408 echo "export BUILD_TARGET" >> $ENV
409 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
410 echo "export BUILD_TARGET_ARCH" >> $ENV
411 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
412 echo "export BUILD_TARGET_CPU" >> $ENV
413 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
414 echo "export BUILD_TYPE" >> $ENV
415}
416
417#
418# Check for gcc with version >= 3.2.
419# We depend on a working gcc, if we fail terminate in every case.
420#
421check_gcc()
422{
423 test_header gcc
424 if check_avail "$CC" CC really; then
425 cc_ver=`$CC -dumpversion` 2>/dev/null
426 if [ $? -ne 0 ]; then
427 log_failure "cannot execute '$CC -dumpversion'"
428 fail really
429 fi
430 if check_avail "$CXX" CXX really; then
431 cxx_ver=`$CXX -dumpversion` 2>/dev/null
432 if [ $? -ne 0 ]; then
433 log_failure "cannot execute '$CXX -dumpversion'"
434 fail really
435 fi
436 cc_maj=`echo $cc_ver|cut -d. -f1`
437 cc_min=`echo $cc_ver|cut -d. -f2`
438 if [ "x$cc_ver" != "x$cxx_ver" ]; then
439 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
440 fail really
441 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
442 log_success "found version $cc_ver"
443 # gcc-4.0 is allowed for Darwin only
444 elif [ $cc_maj -lt 4 \
445 -o \( $cc_maj -eq 4 -a $cc_min -lt 4 -a "$OS" != "darwin" \) \
446 -o \( $cc_maj -eq 4 -a $cc_min -lt 2 -a "$OS" = "darwin" \) \
447 -o $cc_maj -gt 7 ]; then
448 log_failure "gcc version $cc_maj.$cc_min found, expected gcc 4.x, gcc 5.x or gcc 6.x"
449 fail really
450 else
451 log_success "found version $cc_ver"
452 fi
453 if [ "$BUILD_MACHINE" = "amd64" ]; then
454 [ -z "$CC32" ] && CC32="$CC -m32"
455 [ -z "$CXX32" ] && CXX32="$CXX -m32"
456 else
457 [ -z "$CC32" ] && CC32="$CC"
458 [ -z "$CXX32" ] && CXX32="$CXX"
459 fi
460 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
461 [ -z "$CC64" ] && CC64="$CC -m64"
462 [ -z "$CXX64" ] && CXX64="$CXX -m64"
463 fi
464 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
465 CC32="undefined"
466 CXX32="undefined"
467 fi
468 if [ "$CC" != "gcc" ]; then
469 cnf_append "TOOL_GCC3_CC" "$CC"
470 cnf_append "TOOL_GCC3_AS" "$CC"
471 cnf_append "TOOL_GCC3_LD" "$CC"
472 cnf_append "TOOL_GXX3_CC" "$CC"
473 cnf_append "TOOL_GXX3_AS" "$CC"
474 fi
475 if [ "$CXX" != "g++" ]; then
476 cnf_append "TOOL_GCC3_CXX" "$CXX"
477 cnf_append "TOOL_GXX3_CXX" "$CXX"
478 cnf_append "TOOL_GXX3_LD" "$CXX"
479 fi
480 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
481 cnf_append "TOOL_GCC32_CC" "$CC32"
482 cnf_append "TOOL_GCC32_AS" "$CC32"
483 cnf_append "TOOL_GCC32_LD" "$CC32"
484 cnf_append "TOOL_GXX32_CC" "$CC32"
485 cnf_append "TOOL_GXX32_AS" "$CC32"
486 fi
487 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
488 cnf_append "TOOL_GCC32_CXX" "$CXX32"
489 cnf_append "TOOL_GXX32_CXX" "$CXX32"
490 cnf_append "TOOL_GXX32_LD" "$CXX32"
491 fi
492 # this isn't not necessary, there is not such tool.
493 if [ -n "$CC64" ]; then
494 cnf_append "TOOL_GCC64_CC" "$CC64"
495 cnf_append "TOOL_GCC64_AS" "$CC64"
496 cnf_append "TOOL_GCC64_LD" "$CC64"
497 cnf_append "TOOL_GXX64_CC" "$CC64"
498 cnf_append "TOOL_GXX64_AS" "$CC64"
499 fi
500 if [ -n "$CXX64" ]; then
501 cnf_append "TOOL_GCC64_CXX" "$CXX64"
502 cnf_append "TOOL_GXX64_CXX" "$CXX64"
503 cnf_append "TOOL_GXX64_LD" "$CXX64"
504 fi
505 # Solaris sports a 32-bit gcc/g++.
506 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
507 [ "$CC" = "gcc" ] && CC="gcc -m64"
508 [ "$CXX" = "g++" ] && CXX="g++ -m64"
509 fi
510 fi
511 fi
512}
513
514
515#
516# Check for the OpenWatcom compiler, needed for compiling the BIOS
517#
518# If the system has Open Watcom installed, WATCOM will be set in the
519# environment. If the user has her/his own Open Watcom install it will be
520# pointed to by on the command line, which will set the WATCOM variable.
521# The only exception is detecting OpenWatcom in tools/common/openwatcom.
522#
523check_open_watcom()
524{
525 test_header "Open Watcom"
526
527 if [ -z "$WATCOM" ]; then
528 WATCOM=`/bin/ls -rd1 $PWD/tools/common/openwatcom/* 2> /dev/null | head -1`
529 if [ -z "$WATCOM" ]; then
530 log_failure "Open Watcom was not found"
531 cnf_append "VBOX_WITH_OPEN_WATCOM" ""
532 return 0;
533 fi
534 fi
535
536 case "$OS" in
537 "darwin") wc_bin="binosx";; # ??
538 "dos") wc_bin="binw";;
539 "freebsd") wc_bin="binfbsd";; # ??
540 "linux") wc_bin="binl";;
541 "netbsd") wc_bin="binnbsd";; # ??
542 "solaris") wc_bin="binsol";; # ??
543 "os2") wc_bin="binp";;
544 "win") wc_bin="binnt";;
545 *) wc_bin="binl";;
546 esac
547
548 # Check that the tools we use are there.
549 for prog in wasm wcc wlink;
550 do
551 if [ ! -f "$WATCOM/$wc_bin/$prog" ]; then
552 log_failure "$WATCOM/$wc_bin/$prog does not exist or is not a regular file."
553 fail
554 fi
555 done
556
557 # Use WASM to get the version.
558 wasm_ver=`$WATCOM/$wc_bin/wasm -? 2>&1 | sed -e '1!d' -e 's/Open Watcom Assembler Version *//'`
559 if [ -z "$wasm_ver" ]; then
560 log_failure "$WATCOM/$wc_bin/wasm -? did not produce the expected response"
561 fail
562 fi
563 log_success "found version $wasm_ver"
564 cnf_append "PATH_TOOL_OPENWATCOM" "$WATCOM"
565 cnf_append "VBOX_WITH_OPEN_WATCOM" "1"
566
567 unset wasm_ver
568 unset wc_wasm
569 unset wc_bin
570}
571
572
573#
574# Check for yasm, needed to compile assembler files
575#
576check_yasm()
577{
578 test_header yasm
579 if check_avail "$YASM" YASM; then
580 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
581 if [ $? -ne 0 ]; then
582 log_failure "yasm not found"
583 fail
584 else
585 yasm_maj=`echo $yasm_ver|cut -d. -f1`
586 yasm_min=`echo $yasm_ver|cut -d. -f2`
587 yasm_rev=`echo $yasm_ver|cut -d. -f3`
588 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
589 if [ $yasm_ver_mul -lt 501 ]; then
590 log_failure "found version $yasm_ver, expected at least 0.5.1"
591 fail
592 else
593 log_success "found version $yasm_ver"
594 fi
595 fi
596 fi
597}
598
599
600#
601# Check for the iasl ACPI compiler, needed to compile vbox.dsl
602#
603check_iasl()
604{
605 test_header iasl
606 if check_avail "$IASL" IASL; then
607 iasl_ver=`$IASL|grep "ASL.*version"|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
608 if [ $? -ne 0 ]; then
609 log_failure "iasl not found"
610 fail
611 else
612 log_success "found version $iasl_ver"
613 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
614 fi
615 fi
616}
617
618
619#
620# Check for xsltproc, needed by Main
621#
622check_xsltproc()
623{
624 if [ -n "$BUILD_LIBXSLT" ]; then
625 return 0;
626 fi
627 test_header xslt
628 if check_avail "$XSLTPROC" XSLTPROC; then
629 xsltproc_ver=`$XSLTPROC --version`
630 if [ $? -ne 0 ]; then
631 log_failure "xsltproc not found"
632 fail
633 else
634 log_success "found"
635 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
636 fi
637 fi
638}
639
640
641#
642# Check for mkisofs, needed to build the CDROM image containing the additions
643#
644check_mkisofs()
645{
646 test_header mkisofs
647 if which_wrapper $GENISOIMAGE > /dev/null; then
648 mkisofs_ver=`$GENISOIMAGE --version`
649 if [ $? -ne 0 ]; then
650 log_failure "mkisofs not found"
651 fail
652 else
653 log_success "found $mkisofs_ver"
654 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
655 fi
656 elif check_avail "$MKISOFS" MKISOFS; then
657 mkisofs_ver=`$MKISOFS --version`
658 if [ $? -ne 0 ]; then
659 log_failure "mkisofs not working"
660 fail
661 else
662 log_success "found $mkisofs_ver"
663 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
664 fi
665 fi
666}
667
668
669#
670# Check for libxml2, needed by VBoxSettings and Runtime.
671# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
672#
673check_libxml2()
674{
675 if [ -z "$BUILD_LIBXML2" ]; then
676 test_header libxml2
677 if which_wrapper pkg-config > /dev/null; then
678 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
679 if [ $? -ne 0 ]; then
680 log_failure "libxml2 not found"
681 fail
682 else
683 FLGXML2=`pkg-config libxml-2.0 --cflags`
684 INCXML2=`strip_I "$FLGXML2"`
685 LIBXML2=`pkg-config libxml-2.0 --libs`
686 cat > $ODIR.tmp_src.cc << EOF
687#include <cstdio>
688#include <libxml/xmlversion.h>
689extern "C" int main(void)
690{
691 printf("found version %s", LIBXML_DOTTED_VERSION);
692#if LIBXML_VERSION >= 20626
693 printf(", OK.\n");
694 return 0;
695#else
696 printf(", expected version 2.6.26 or higher\n");
697 return 1;
698#endif
699}
700EOF
701 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
702 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
703 if test_execute; then
704 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
705 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
706 fi
707 fi
708 fi
709 elif which_wrapper xml2-config; then
710 libxml2_ver=`xml2-config --version`
711 if [ $? -ne 0 ]; then
712 log_failure "xml2-config not found"
713 fail
714 else
715 log_success "found version $libxml2_ver"
716 FLGXML2=`xml2-config --cflags`
717 INCXML2=`strip_I "$FLGXML2"`
718 LIBXML2=`xml2-config --libs`
719 cat > $ODIR.tmp_src.cc << EOF
720#include <cstdio>
721#include <libxml/xmlversion.h>
722extern "C" int main(void)
723{
724 printf("found version %s", LIBXML_DOTTED_VERSION);
725#if LIBXML_VERSION >= 20626
726 printf(", OK.\n");
727 return 0;
728#else
729 printf(", expected version 2.6.26 or higher\n");
730 return 1;
731#endif
732}
733EOF
734 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
735 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
736 if test_execute; then
737 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
738 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
739 fi
740 fi
741 fi
742 else
743 log_failure "neither pkg-config nor xml2-config found"
744 fail
745 fi
746 fi
747}
748
749
750#
751# Check for libIDL, needed by xpcom
752#
753check_libidl()
754{
755 test_header libIDL
756
757 if which_wrapper libIDL-config-2 > /dev/null; then
758 libidl_ver=`libIDL-config-2 --version`
759 if [ $? -ne 0 ]; then
760 log_failure "libIDL-config-2 not working"
761 fail
762 else
763 log_success "found version $libidl_ver"
764 cnf_append "VBOX_LIBIDL_CONFIG" \
765 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
766 fi
767 elif check_avail "libIDL-config" libIDL-config; then
768 libidl_ver=`libIDL-config --version`
769 if [ $? -ne 0 ]; then
770 log_failure "libIDL-config not working"
771 fail
772 else
773 log_success "found version $libidl_ver"
774 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
775 fi
776 fi
777}
778
779
780#
781# Check for libdevmapper, needed by the VBoxVolInfo
782#
783check_libdevmapper()
784{
785 test_header libdevmapper
786 cat > $ODIR.tmp_src.cc << EOF
787#include <cstdio>
788extern "C" {
789#define private
790#include <libdevmapper.h>
791int main()
792{
793 char version[80];
794
795 if (!dm_get_library_version(version, sizeof(version)))
796 {
797 printf("dm_get_library_version() failed.\n");
798 return 1;
799 }
800
801 const char* v=version;
802 unsigned int major = 0, minor = 0, micro = 0;
803
804 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
805 if (*v == '.') v++;
806 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
807 if (*v == '.') v++;
808 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
809
810 printf("found version %s", version);
811 if (major*10000 + minor*100 + micro >= 10200)
812 {
813 printf(", OK.\n");
814 return 0;
815 }
816 else
817 {
818 printf(", expected version 1.02 or higher\n");
819 return 1;
820 }
821}
822}
823EOF
824 if test_compile "$LIBDEVMAPPER $INCDEVMAPPER" libdevmapper libdevmapper; then
825 if test_execute; then
826 cnf_append "VBOX_WITH_DEVMAPPER" "1"
827 fi
828 fi
829}
830
831
832#
833# Check for openssl, needed for RDP and S3
834#
835check_ssl()
836{
837 if [ -z "$BUILD_LIBSSL" ]; then
838 test_header ssl
839 cat > $ODIR.tmp_src.cc << EOF
840#include <cstdio>
841#include <openssl/opensslv.h>
842#include <openssl/ssl.h>
843extern "C" int main(void)
844{
845 printf("found version %s", OPENSSL_VERSION_TEXT);
846 SSL_library_init();
847#if OPENSSL_VERSION_NUMBER >= 0x00908000
848 printf(", OK.\n");
849 return 0;
850#else
851 printf(", expected version 0.9.8 or higher\n");
852 return 1;
853#endif
854}
855EOF
856 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
857 if test_execute nofatal; then
858 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
859 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
860 cnf_append "SDK_VBOX_BLD_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
861 fi
862 fi
863 fi
864}
865
866
867#
868# Check for pthread, needed by VBoxSVC, frontends, ...
869#
870check_pthread()
871{
872 test_header pthread
873 cat > $ODIR.tmp_src.cc << EOF
874#include <cstdio>
875#include <pthread.h>
876extern "C" int main(void)
877{
878 pthread_mutex_t mutex;
879 if (pthread_mutex_init(&mutex, NULL)) {
880 printf("pthread_mutex_init() failed\n");
881 return 1;
882 }
883 if (pthread_mutex_lock(&mutex)) {
884 printf("pthread_mutex_lock() failed\n");
885 return 1;
886 }
887 if (pthread_mutex_unlock(&mutex)) {
888 printf("pthread_mutex_unlock() failed\n");
889 return 1;
890 }
891 printf("found, OK.\n");
892}
893EOF
894 if test_compile $LIBPTHREAD pthread pthread; then
895 if test_execute; then
896 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
897 fi
898 fi
899}
900
901
902#
903# Check for zlib, needed by VBoxSVC, Runtime, ...
904#
905check_z()
906{
907 test_header zlib
908 cat > $ODIR.tmp_src.cc << EOF
909#include <cstdio>
910#include <zlib.h>
911extern "C" int main(void)
912{
913 printf("found version %s", ZLIB_VERSION);
914#if ZLIB_VERNUM >= 0x1210
915 printf(", OK.\n");
916 return 0;
917#else
918 printf(", expected version 1.2.1 or higher\n");
919 return 1;
920#endif
921}
922EOF
923 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
924 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
925 if test_execute; then
926 echo "if1of (\$(KBUILD_TARGET),darwin freebsd haiku linux)" >> $CNF
927 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
928 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
929 echo "endif" >> $CNF
930 fi
931 fi
932}
933
934
935#
936# Check for libpng, needed by kchmviewer
937#
938check_png()
939{
940 test_header libpng
941 cat > $ODIR.tmp_src.cc << EOF
942#include <cstdio>
943#include <png.h>
944extern "C" int main(void)
945{
946 printf("found version %s", PNG_LIBPNG_VER_STRING);
947#if PNG_LIBPNG_VER >= 10205
948 printf(", OK.\n");
949 return 0;
950#else
951 printf(", expected version 1.2.5 or higher\n");
952 return 1;
953#endif
954}
955EOF
956 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
957 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
958 if test_execute; then
959 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
960 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
961 fi
962 fi
963}
964
965#
966# Check for libvncserver, needed for VNC in OSE
967#
968check_vncserver()
969{
970 test_header libvncserver
971 cat > $ODIR.tmp_src.cc <<EOF
972#include <cstdio>
973#include <rfb/rfbconfig.h>
974
975extern "C" int main()
976{
977 const char* v=LIBVNCSERVER_VERSION;
978 unsigned int major = 0, minor = 0, micro = 0;
979
980 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
981 if (*v == '.') v++;
982 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
983 if (*v == '.') v++;
984 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
985
986 printf("found version %s", LIBVNCSERVER_PACKAGE_VERSION);
987 if (major*10000 + minor*100 + micro >= 900)
988 {
989 printf(", OK.\n");
990 return 0;
991 }
992 else
993 {
994 printf(", expected version 0.9 or higher\n");
995 return 1;
996 }
997}
998EOF
999 if test_compile "$LIBVNCSERVER $INCVNCSERVER" libvncserver libvncserver; then
1000 if test_execute; then
1001 cnf_append "VBOX_WITH_EXTPACK_VNC" "1"
1002 fi
1003 fi
1004}
1005
1006#
1007# Check for libcurl, needed by S3
1008#
1009check_curl()
1010{
1011 if [ -z "$BUILD_LIBCURL" ]; then
1012 test_header libcurl
1013 cat > $ODIR.tmp_src.cc << EOF
1014#include <cstdio>
1015#include <curl/curl.h>
1016extern "C" int main(void)
1017{
1018 printf("found version %s", LIBCURL_VERSION);
1019#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71901
1020 printf(", OK.\n");
1021 return 0;
1022#else
1023 printf(", expected version 7.19.1 or higher\n");
1024 return 1;
1025#endif
1026}
1027EOF
1028 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
1029 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
1030 if test_execute; then
1031 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
1032 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
1033 fi
1034 fi
1035 fi
1036}
1037
1038
1039#
1040# Check for pam, needed by VRDPAuth
1041# Version 79 was introduced in 9/2005, do we support older versions?
1042# Debian/sarge uses 76
1043# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
1044#
1045check_pam()
1046{
1047 test_header pam
1048 cat > $ODIR.tmp_src.cc << EOF
1049#include <cstdio>
1050#include <security/pam_appl.h>
1051extern "C" int main(void)
1052{
1053 printf("found version %d", __LIBPAM_VERSION);
1054 if (__LIBPAM_VERSION >= 76)
1055 {
1056 printf(", OK.\n");
1057 return 0;
1058 }
1059 else
1060 {
1061 printf(", expected version 76 or higher\n");
1062 return 1;
1063 }
1064}
1065EOF
1066 if test_compile "-lpam" pam pam nofatal; then
1067 if test_execute nofatal; then
1068 return 0;
1069 fi
1070 fi
1071 echo "pam0.x not found"
1072 test_header linux_pam
1073 cat > $ODIR.tmp_src.cc << EOF
1074#include <cstdio>
1075#include <security/pam_appl.h>
1076extern "C" int main(void)
1077{
1078 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1079 if (__LINUX_PAM__ >= 1)
1080 {
1081 printf(", OK.\n");
1082 return 0;
1083 }
1084 else
1085 {
1086 printf(", expected version 1.0 or higher\n");
1087 return 1;
1088 }
1089}
1090EOF
1091 if test_compile "-lpam" pam pam; then
1092 test_execute
1093 fi
1094}
1095
1096
1097#
1098# Check for the SDL library, needed by VBoxSDL and VirtualBox
1099# We depend at least on version 1.2.7
1100#
1101check_sdl()
1102{
1103 test_header SDL
1104 if [ "$OS" = "darwin" ]; then
1105 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1106 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1107 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1108 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1109 fi
1110 if [ -n "$PATH_SDK_LIBSDL" ]; then
1111 foundsdl=1
1112 INCSDL="$PATH_SDK_LIBSDL/Headers"
1113 FLDSDL="-framework SDL"
1114 else
1115 log_failure "SDL framework not found"
1116 fail
1117 fi
1118 else
1119 if which_wrapper sdl-config > /dev/null; then
1120 FLGSDL=`sdl-config --cflags`
1121 INCSDL=`strip_I "$FLGSDL"`
1122 LIBSDL=`sdl-config --libs`
1123 LIBSDLMAIN="-lSDLmain"
1124 FLDSDL=
1125 foundsdl=1
1126 fi
1127 fi
1128 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1129 if [ -n "$foundsdl" ]; then
1130 cat > $ODIR.tmp_src.cc << EOF
1131#include <cstdio>
1132#include <SDL.h>
1133#include <SDL_main.h>
1134#undef main
1135extern "C" int main(int argc, char** argv)
1136{
1137 printf("found version %d.%d.%d",
1138 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1139#if SDL_VERSION_ATLEAST(1,2,7)
1140 printf(", OK.\n");
1141 return 0;
1142#else
1143 printf(", expected version 1.2.7 or higher\n");
1144 return 1;
1145#endif
1146}
1147EOF
1148 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1149 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1150 if test_execute; then
1151 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1152 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1153 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1154 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1155 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1156 fi
1157 fi
1158 else
1159 log_failure "SDL not found (can be disabled using --disable-sdl)"
1160 fail
1161 fi
1162}
1163
1164
1165#
1166# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1167#
1168check_sdl_ttf()
1169{
1170 test_header SDL_ttf
1171 cat > $ODIR.tmp_src.cc << EOF
1172#include <cstdio>
1173#include <SDL_ttf.h>
1174#ifndef SDL_TTF_MAJOR_VERSION
1175#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1176#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1177#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1178#endif
1179extern "C" int main(void)
1180{
1181 printf("found version %d.%d.%d",
1182 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1183#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1184 printf(", OK.\n");
1185 return 0;
1186#else
1187 printf(", expected version 2.0.6 or higher\n");
1188 return 1;
1189#endif
1190}
1191EOF
1192 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1193 test_execute nofatal || \
1194 cnf_append "VBOX_WITH_SECURELABEL" ""
1195 else
1196 echo "not found -- disabling VBoxSDL secure label."
1197 cnf_append "VBOX_WITH_SECURELABEL" ""
1198 fi
1199}
1200
1201
1202#
1203# Check for libasound, needed by the ALSA audio backend
1204#
1205check_alsa()
1206{
1207 test_header ALSA
1208 cat > $ODIR.tmp_src.cc << EOF
1209#include <cstdio>
1210#include <alsa/asoundlib.h>
1211extern "C" int main(void)
1212{
1213 printf("found version %d.%d.%d",
1214 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1215#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10014
1216 printf(", OK.\n");
1217 return 0;
1218#else
1219 printf(", expected version 1.0.14 or higher\n");
1220 return 1;
1221#endif
1222}
1223EOF
1224 if test_compile "-lasound" asound asound; then
1225 test_execute
1226 fi
1227}
1228
1229
1230#
1231# Check for PulseAudio
1232#
1233check_pulse()
1234{
1235 test_header "PulseAudio"
1236 cat > $ODIR.tmp_src.cc << EOF
1237#include <cstdio>
1238#include <pulse/version.h>
1239extern "C" int main(void)
1240{
1241 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1242#if PA_API_VERSION >= 9
1243 printf(", OK.\n");
1244 return 0;
1245#else
1246 printf(", expected version 0.9.0 (API version 9) or higher\n");
1247 return 1;
1248#endif
1249}
1250EOF
1251 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1252 test_execute
1253 fi
1254}
1255
1256
1257#
1258# Check for the X libraries (Xext, X11)
1259#
1260check_x()
1261{
1262 test_header "X libraries"
1263 cat > $ODIR.tmp_src.cc << EOF
1264#include <cstdio>
1265#include <X11/Xlib.h>
1266extern "C" int main(void)
1267{
1268 Display *dpy;
1269 int scrn_num;
1270 Screen *scrn;
1271 Window win;
1272
1273 dpy = XOpenDisplay(NULL);
1274 scrn_num = DefaultScreen(dpy);
1275 scrn = ScreenOfDisplay(dpy, scrn_num);
1276 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1277 0, 16, InputOutput, CopyFromParent, 0, NULL);
1278 XDestroyWindow(dpy, win);
1279 XCloseDisplay(dpy);
1280}
1281EOF
1282 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1283 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1284 log_success "found"
1285 fi
1286}
1287
1288
1289#
1290# Check for the Xcursor library, needed by VBoxSDL.
1291#
1292check_xcursor()
1293{
1294 test_header Xcursor
1295 cat > $ODIR.tmp_src.cc << EOF
1296#include <cstdio>
1297#include <X11/Xlib.h>
1298#include <X11/Xcursor/Xcursor.h>
1299extern "C" int main(void)
1300{
1301 XcursorImage *cursor = XcursorImageCreate (10, 10);
1302 XcursorImageDestroy(cursor);
1303 return 0;
1304}
1305EOF
1306 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1307 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1308 log_success "found"
1309 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1310 fi
1311}
1312
1313
1314#
1315# Check for the Xinerama library, needed by the Qt GUI
1316#
1317check_xinerama()
1318{
1319 test_header Xinerama
1320 cat > $ODIR.tmp_src.cc << EOF
1321#include <X11/Xlib.h>
1322#include <X11/extensions/Xinerama.h>
1323extern "C" int main(void)
1324{
1325 Display *dpy;
1326 Bool flag;
1327 dpy = XOpenDisplay(NULL);
1328 if (dpy)
1329 {
1330 flag = XineramaIsActive(dpy);
1331 XCloseDisplay(dpy);
1332 }
1333}
1334EOF
1335 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1336 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1337 log_success "found"
1338 fi
1339}
1340
1341
1342#
1343# Check for the Xinerama library, needed by the Qt GUI
1344#
1345check_xrandr()
1346{
1347 test_header Xrandr
1348 cat > $ODIR.tmp_src.cc << EOF
1349#include <X11/Xlib.h>
1350#include <X11/extensions/Xrandr.h>
1351extern "C" int main(void)
1352{
1353 Display *dpy;
1354 Bool flag;
1355 int major, minor;
1356 dpy = XOpenDisplay(NULL);
1357 if (dpy)
1358 {
1359 flag = XRRQueryVersion(dpy, &major, &minor);
1360 XCloseDisplay(dpy);
1361 }
1362}
1363EOF
1364 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1365 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1366 log_success "found"
1367 fi
1368}
1369
1370
1371#
1372# Check for OpenGL
1373#
1374check_opengl()
1375{
1376 # On darwin this is a on/off decision only
1377 if [ "$OS" = "darwin" ]; then
1378 test_header "OpenGL support"
1379 echo "enabled"
1380 cnf_append "VBOX_WITH_CROGL" "1"
1381 else
1382 check_xmu
1383 check_mesa
1384 fi
1385}
1386
1387
1388#
1389# Check for the Xmu library, needed by OpenGL
1390#
1391check_xmu()
1392{
1393 test_header Xmu
1394 cat > $ODIR.tmp_src.cc << EOF
1395#include <cstdio>
1396#include <X11/Xatom.h>
1397#include <X11/Xlib.h>
1398#include <X11/Xutil.h>
1399#include <X11/Xmu/StdCmap.h>
1400extern "C" int main(void)
1401{
1402 Display *dpy;
1403 int scrn_num;
1404 Screen *scrn;
1405
1406 dpy = XOpenDisplay(NULL);
1407 if (dpy)
1408 {
1409 scrn_num = DefaultScreen(dpy);
1410 scrn = ScreenOfDisplay(dpy, scrn_num);
1411 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1412 24, XA_RGB_DEFAULT_MAP, False, True);
1413 printf("Status = %x\n", status);
1414 XCloseDisplay(dpy);
1415 }
1416 return 0;
1417}
1418EOF
1419 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1420 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1421 log_success "found"
1422 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1423 fi
1424}
1425
1426#
1427# Check for Mesa, needed by OpenGL
1428#
1429check_mesa()
1430{
1431 test_header "Mesa / GLU"
1432 cat > $ODIR.tmp_src.cc << EOF
1433#include <cstdio>
1434#include <X11/Xlib.h>
1435#include <GL/glx.h>
1436#include <GL/glu.h>
1437extern "C" int main(void)
1438{
1439 Display *dpy;
1440 int major, minor;
1441
1442 dpy = XOpenDisplay(NULL);
1443 if (dpy)
1444 {
1445 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1446 XCloseDisplay(dpy);
1447 if (glx_version)
1448 {
1449 printf("found version %u.%u, OK.\n", major, minor);
1450 return 0;
1451 }
1452 }
1453 printf("found (inactive), OK.\n");
1454 return 0;
1455}
1456EOF
1457 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1458 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1459 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1460 test_execute
1461 fi
1462}
1463
1464
1465#
1466# Check for the Qt4 library, needed by the VirtualBox frontend
1467#
1468# Currently not fatal.
1469#
1470check_qt4()
1471{
1472 foundqt4=
1473 test_header Qt4
1474 cat > $ODIR.tmp_src.cc << EOF
1475#include <QtGlobal>
1476extern "C" int main(void)
1477{
1478#if QT_VERSION >= 0x040800
1479 return 0;
1480#else
1481 return 1;
1482#endif
1483}
1484EOF
1485 if [ "$OS" = "darwin" ]; then
1486 # First check if there is the internal version of Qt. If yes nothing else
1487 # has to be done.
1488 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1489 for t in $QT_INTERNAL; do
1490 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1491 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1492 log_success "use internal version"
1493 return
1494 fi
1495 done
1496 # Now try the user provided directory and some of the standard directories.
1497 QT_TRIES="$QT4DIR /System/Library /Library"
1498 for t in $QT_TRIES; do
1499 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1500 PATH_SDK_QT4="$t"
1501 break
1502 fi
1503 done
1504 # Add the necessary params for building the test application
1505 if [ -n "$PATH_SDK_QT4" ]; then
1506 foundqt4=1
1507 INCQT4=-I$PATH_SDK_QT4/Frameworks/QtCore.framework/Headers
1508 LIBQT4=-F$PATH_SDK_QT4/Frameworks
1509 FLGQT4="-framework QtCore"
1510 else
1511 log_failure "Qt4 framework not found (can be disabled using --disable-qt)"
1512 fail
1513 fi
1514 else # !darwin
1515 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1516 # default is to use pkg-config
1517 if which_wrapper pkg-config > /dev/null; then
1518 qt4_ver=`pkg-config QtCore --modversion 2>> $LOG`
1519 if [ $? -eq 0 ]; then
1520 FLGQT4=`pkg-config QtCore --cflags`
1521 INCQT4=`strip_I "$FLGQT4"`
1522 LIBQT4=`PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 pkg-config QtCore --libs`
1523 TOOLQT4=`pkg-config QtCore --variable=prefix`
1524 TOOLQT4MOC="`pkg-config QtCore --variable=moc_location`"
1525 TOOLQT4BIN="`dirname $TOOLQT4MOC`"
1526 if test_compile "$LIBQT4 $LIBPTHREAD $FLGQT4" qt4 qt4 nofatal; then
1527 test_execute_path "`strip_L "$LIBQT4"`" nofatal && foundqt4=3 # pkg-config
1528 fi
1529 fi
1530 else
1531 log_failure "pkg-config not found"
1532 fail
1533 fi
1534 fi
1535 if [ -z "$foundqt4" ]; then
1536 # do it the old way (e.g. user has specified QT4DIR)
1537 for q in $QT4DIR "$PWD/tools/linux.$TARGET_MACHINE"/qt/v4.8.*; do
1538 INCQT4="$q/include $q/include/QtCore"
1539 FLGQT4="-DQT_SHARED"
1540 I_INCQT4=`prefix_I "$INCQT4"`
1541 LIBQT4="-L$q/lib -lQtCoreVBox"
1542 TOOLQT4="$q"
1543 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal &&
1544 test_execute_path "`strip_L "$LIBQT4"`" nofatal; then
1545 foundqt4=2 # internal
1546 break;
1547 fi
1548 LIBQT4="-L$q/lib -lQtCore"
1549 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal &&
1550 test_execute_path "`strip_L "$LIBQT4"`" nofatal; then
1551 foundqt4=1 # no pkg-config, Qt directory
1552 break;
1553 fi
1554 done
1555 fi
1556 fi
1557 if [ -n "$foundqt4" ]; then
1558 # we decided which version of Qt to use. Now enforce the version requirement
1559 cat > $ODIR.tmp_src.cc << EOF
1560#include <cstdio>
1561#include <QtGlobal>
1562extern "C" int main(void)
1563{
1564 printf("found version %s", QT_VERSION_STR);
1565#if QT_VERSION >= 0x040800
1566 printf(", OK.\n");
1567 return 0;
1568#else
1569 printf(", expected version 4.8.0 or higher\n");
1570 return 1;
1571#endif
1572}
1573EOF
1574 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1575 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1576 if test_execute_path "`strip_L "$LIBQT4"`"; then
1577 if [ "$OS" = "darwin" ]; then
1578 # Successful build & run the test application so add the necessary
1579 # params to AutoConfig.kmk
1580 cnf_append "PATH_SDK_QT4_INC" "$PATH_SDK_QT4/Frameworks"
1581 cnf_append "PATH_SDK_QT4_LIB" "$PATH_SDK_QT4/Frameworks"
1582 cnf_append "PATH_SDK_QT4" "$PATH_SDK_QT4/Frameworks"
1583 # Check for the moc tool in the Qt directory found & some standard
1584 # directories.
1585 for q in $PATH_SDK_QT4 /usr /Developer/Tools/Qt; do
1586 if which_wrapper "$q/bin/moc" > /dev/null; then
1587 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1588 fi
1589 done
1590 else
1591 # strip .../QtCore as we add components ourself
1592 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1593 # store only the first path, remove all other pathes
1594 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1595 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1596 cnf_append "VBOX_PATH_QT_LIB" "`strip_L "$LIBQT4"`"
1597 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1598 # this is not quite right since the qt libpath does not have to be first...
1599 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1600 if [ "$foundqt4" = "2" ]; then
1601 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1602 fi
1603 if [ "$foundqt4" != "3" ]; then
1604 TOOLQT4BIN="$TOOLQT4/bin"
1605 fi
1606 test_header "Qt4 devtools"
1607 # try it with a suffix, some platforms use that
1608 if which_wrapper "$TOOLQT4BIN/moc-qt4" > /dev/null; then
1609 QT4BINSUFF="-qt4"
1610 else
1611 QT4BINSUFF=""
1612 fi
1613 moc_ver=`$TOOLQT4BIN/moc$QT4BINSUFF -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1614 if [ $? -ne 0 ]; then
1615 log_failure "moc$QT4BINSUFF not working"
1616 fail
1617 else
1618 log_success "found version $moc_ver"
1619 cnf_append "VBOX_PATH_QT" "$TOOLQT4"
1620 cnf_append "PATH_SDK_QT4" "$TOOLQT4"
1621 cnf_append "PATH_TOOL_QT4_BIN" "$TOOLQT4BIN"
1622 [ -n "$QT4BINSUFF" ] && cnf_append "TOOL_QT4_BIN_SUFF" "$QT4BINSUFF"
1623 fi
1624 fi
1625 fi
1626 else
1627 log_failure "qt4 not working"
1628 fail
1629 fi
1630 else
1631 log_failure "qt4 not found"
1632 fail
1633 fi
1634}
1635
1636
1637#
1638# Check for the Qt5 library, needed by the VirtualBox frontend
1639#
1640# Currently not fatal.
1641#
1642check_qt5()
1643{
1644 foundqt5=
1645 test_header Qt5
1646 cat > $ODIR.tmp_src.cc << EOF
1647#include <QtGlobal>
1648extern "C" int main(void)
1649{
1650#if QT_VERSION >= 0x050302
1651 return 0;
1652#else
1653 return 1;
1654#endif
1655}
1656EOF
1657 if [ "$OS" = "darwin" ]; then
1658 # First check if there is the internal version of Qt. If yes nothing else
1659 # has to be done.
1660 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1661 for t in $QT_INTERNAL; do
1662 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1663 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1664 log_success "use internal version"
1665 return
1666 fi
1667 done
1668 # Now try the user provided directory and some of the standard directories.
1669 QT_TRIES="$QT5DIR /System/Library /Library"
1670 for t in $QT_TRIES; do
1671 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1672 PATH_SDK_QT5="$t"
1673 break
1674 fi
1675 done
1676 # Add the necessary params for building the test application
1677 if [ -n "$PATH_SDK_QT5" ]; then
1678 foundqt5=1
1679 INCQT5=-I$PATH_SDK_QT5/Frameworks/QtCore.framework/Headers
1680 LIBQT5=-F$PATH_SDK_QT5/Frameworks
1681 FLGQT5="-framework QtCore"
1682 else
1683 log_failure "Qt5 framework not found (can be disabled using --disable-qt)"
1684 fail
1685 fi
1686 else # !darwin
1687 if [ $QT5DIR_PKGCONFIG -eq 1 ]; then
1688 # Default is to use pkg-config:
1689 if which_wrapper pkg-config > /dev/null; then
1690 qt5_ver=`pkg-config Qt5Core --modversion 2>> $LOG`
1691 if [ $? -eq 0 ]; then
1692 echo "(Qt5 from pkg-config)" >> $LOG
1693 FLGQT5=`pkg-config Qt5Core --cflags`
1694 # gcc 4.8 is able to compile with C++11 (see also VBOX_GCC_std in Config.kmk)
1695 [ $cc_maj -eq 4 -a $cc_min -eq 8 ] && FLGQT5="$FLGQT5 -std=c++11"
1696 INCQT5=`strip_I "$FLGQT5"`
1697 LIBDIR5=`pkg-config Qt5Core --variable=libdir`
1698 LIBQT5=`pkg-config Qt5Core --libs`
1699 LIBQT5="-L$LIBDIR5 $LIBQT5"
1700 TOOLQT5=`pkg-config Qt5Core --variable=prefix`
1701 TOOLQT5BIN=`pkg-config Qt5Core --variable=host_bins`
1702 if test_compile "$LIBQT5 $LIBPTHREAD $FLGQT5" qt5 qt5 nofatal; then
1703 test_execute_path "`strip_L "$LIBQT5"`" nofatal && foundqt5=3 # pkg-config
1704 fi
1705 fi
1706 else
1707 log_failure "pkg-config not found"
1708 fail
1709 fi
1710 fi
1711 if [ -z "$foundqt5" ]; then
1712 # Do it the old way (e.g. user has specified QT5DIR):
1713 for q in $QT5DIR "$PWD/tools/linux.$TARGET_MACHINE"/qt/v5.*; do
1714 echo "(Qt5 from '$q')" >> $LOG
1715 INCQT5="$q/include $q/include/QtCore"
1716 FLGQT5="-DQT_SHARED"
1717 I_INCQT5=`prefix_I "$INCQT5"`
1718 LIBQT5="-L$q/lib -lQt5CoreVBox"
1719 TOOLQT5="$q"
1720 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal &&
1721 test_execute_path "`strip_L "$LIBQT5"`" nofatal; then
1722 foundqt5=2 # internal
1723 break;
1724 fi
1725 LIBQT5="-L$q/lib -lQt5Core"
1726 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal &&
1727 test_execute_path "`strip_L "$LIBQT5"`" nofatal; then
1728 foundqt5=1 # no pkg-config, Qt directory
1729 break;
1730 fi
1731 done
1732 fi
1733 fi
1734 if [ -n "$foundqt5" ]; then
1735 # We decided which version of Qt to use, now enforce the version requirement:
1736 cat > $ODIR.tmp_src.cc << EOF
1737#include <cstdio>
1738#include <QtGlobal>
1739extern "C" int main(void)
1740{
1741 printf("found version %s", QT_VERSION_STR);
1742#if QT_VERSION >= 0x050302
1743 printf(", OK.\n");
1744 return 0;
1745#else
1746 printf(", expected version 5.3.2 or higher\n");
1747 return 1;
1748#endif
1749}
1750EOF
1751 [ -n "$INCQT5" ] && I_INCQT5=`prefix_I "$INCQT5"`
1752 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal; then
1753 if test_execute_path "`strip_L "$LIBQT5"`"; then
1754 if [ "$OS" = "darwin" ]; then
1755 # Successful build & run the test application so add the necessary
1756 # params to AutoConfig.kmk:
1757 cnf_append "PATH_SDK_QT5_INC" "$PATH_SDK_QT5/Frameworks"
1758 cnf_append "PATH_SDK_QT5_LIB" "$PATH_SDK_QT5/Frameworks"
1759 cnf_append "PATH_SDK_QT5" "$PATH_SDK_QT5/Frameworks"
1760 # Check for the moc tool in the Qt directory found & some standard
1761 # directories.
1762 for q in $PATH_SDK_QT5 /usr /Developer/Tools/Qt; do
1763 if which_wrapper "$q/bin/moc" > /dev/null; then
1764 cnf_append "PATH_TOOL_QT5_BIN" "$q/bin"
1765 fi
1766 done
1767 else
1768 # Strip .../QtCore as we add components ourself:
1769 INCQT5=`echo "$INCQT5"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1770 # store only the first path, remove all other paths
1771 # most likely pkg-config gave us -I/usr/include/qt5 -I/usr/include/qt5/QtCore
1772 INCQT5=`echo "$INCQT5"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1773 cnf_append "VBOX_PATH_QT_LIB" "`strip_L "$LIBQT5"`"
1774 cnf_append "PATH_SDK_QT5_INC" "$INCQT5"
1775 # This is not quite right since the qt libpath does not have to be first...
1776 cnf_append "PATH_SDK_QT5_LIB" '$'"(firstword `strip_L "$LIBQT5"`)"
1777 if [ "$foundqt5" = "2" ]; then
1778 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1779 fi
1780 if [ "$foundqt5" != "3" ]; then
1781 TOOLQT5BIN="$TOOLQT5/bin"
1782 fi
1783 test_header "Qt5 devtools"
1784 # Try it with a suffix, some platforms use that
1785 if which_wrapper "$TOOLQT5BIN/moc-qt5" > /dev/null; then
1786 QT5BINSUFF="-qt5"
1787 else
1788 QT5BINSUFF=""
1789 fi
1790 moc_ver=`$TOOLQT5BIN/moc$QT5BINSUFF -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1791 if [ $? -ne 0 ]; then
1792 log_failure "moc$QT5BINSUFF not working"
1793 fail
1794 else
1795 log_success "found version $moc_ver"
1796 cnf_append "VBOX_PATH_QT" "$TOOLQT5"
1797 cnf_append "PATH_SDK_QT5" "$TOOLQT5"
1798 cnf_append "PATH_TOOL_QT5_BIN" "$TOOLQT5BIN"
1799 [ -n "$QT5BINSUFF" ] && cnf_append "TOOL_QT5_BIN_SUFF" "$QT5BINSUFF"
1800 fi
1801 fi
1802 fi
1803 else
1804 log_failure "qt5 not working"
1805 fail
1806 fi
1807 else
1808 log_failure "qt5 not found"
1809 fail
1810 fi
1811}
1812
1813
1814#
1815# Check for libvpx
1816#
1817check_vpx()
1818{
1819 if [ -z "$BUILD_LIBVPX" ]; then
1820 test_header libvpx
1821 if which_wrapper pkg-config > /dev/null; then
1822 libvpx_ver=`pkg-config vpx --modversion 2>> $LOG`
1823 if [ $? -eq 0 ]; then
1824 FLGVPX=`pkg-config vpx --cflags`
1825 INCVPX=`strip_I "$FLGVPX"`
1826 LIBVPX=`pkg-config vpx --libs`
1827 fi
1828 cat > $ODIR.tmp_src.cc << EOF
1829#include <cstdio>
1830#include <vpx/vpx_codec.h>
1831extern "C" int main(void)
1832{
1833 int version = vpx_codec_version();
1834 int verMajor = VPX_VERSION_MAJOR(version);
1835 int verMinor = VPX_VERSION_MINOR(version);
1836 int verPatch = VPX_VERSION_PATCH(version);
1837 printf("found version %d.%d.%d", verMajor, verMinor, verPatch);
1838 if ( verMajor == 1 && verMinor >= 0
1839 || verMajor == 0 && verMinor == 9 && verPatch >= 5)
1840 {
1841 printf(", OK.\n");
1842 return 0;
1843 }
1844 else
1845 {
1846 printf(", expected version 0.9.5 or higher\n");
1847 return 1;
1848 }
1849}
1850EOF
1851 [ -n "$INCVPX" ] && I_INCVPX=`prefix_I "$INCVPX"`
1852 if test_compile "$LIBVPX $I_INCVPX" vpx vpx; then
1853 if test_execute; then
1854 cnf_append "SDK_VBOX_VPX_INCS" "$INCVPX"
1855 cnf_append "SDK_VBOX_VPX_LIBS" "`strip_l "$LIBVPX"`"
1856 fi
1857 fi
1858 fi
1859 fi
1860}
1861
1862
1863#
1864# Check whether static libstdc++ is installed. This library is required
1865# for the Linux guest additions.
1866#
1867check_staticlibstdcxx()
1868{
1869 test_header "static stc++ library"
1870 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1871 cat > $ODIR.tmp_src.cc << EOF
1872#include <string>
1873
1874extern "C" int main(void)
1875{
1876 std::string s = "test";
1877 return 0;
1878}
1879EOF
1880 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1881 log_success "found"
1882 fi
1883}
1884
1885
1886#
1887# Check for Linux sources
1888#
1889check_linux()
1890{
1891 test_header "Linux kernel sources"
1892 cat > $ODIR.tmp_src.c << EOF
1893#include <linux/version.h>
1894int printf(const char *format, ...);
1895int main(void)
1896{
1897 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1898 (LINUX_VERSION_CODE % 65536) / 256,
1899 LINUX_VERSION_CODE % 256);
1900#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1901 printf(", OK.\n");
1902 return 0;
1903#else
1904 printf(", expected version 2.4.0 or higher\n");
1905 return 1;
1906#endif
1907}
1908EOF
1909 echo "compiling the following source file:" >> $LOG
1910 cat $ODIR.tmp_src.c >> $LOG
1911 echo "using the following command line:" >> $LOG
1912 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include " \
1913 "-I$LINUX/include/generated/uapi" >> $LOG
1914 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include \
1915 -I$LINUX/include/generated/uapi >> $LOG 2>&1
1916 if [ $? -ne 0 ]; then
1917 echo
1918 echo " Linux kernel headers not found at $LINUX"
1919 echo " Check the file $LOG for detailed error information."
1920 fail
1921 else
1922 if test_execute; then
1923 cat > $ODIR.tmp_src.c << EOF
1924#include <linux/version.h>
1925int printf(const char *format, ...);
1926int main(void)
1927{
1928 return LINUX_VERSION_CODE >= KERNEL_VERSION(4,9,0) ? 1 : 0;
1929}
1930EOF
1931 echo "compiling the following source file:" >> $LOG
1932 cat $ODIR.tmp_src.c >> $LOG
1933 echo "using the following command line:" >> $LOG
1934 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include " \
1935 "-I$LINUX/include/generated/uapi" >> $LOG
1936 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include \
1937 -I$LINUX/include/generated/uapi >> $LOG 2>&1
1938 if [ $? -eq 0 ]; then
1939 $ODIR.tmp_out
1940 if [ $? -ne 0 ]; then
1941 cnf_append "VBOX_WITH_VBOXDRV" ""
1942 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
1943 echo "Detected Linux >= 4.8 -- disabling compiling of Linux kernel modules."
1944 else
1945 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1946 fi
1947 fi
1948 fi
1949 fi
1950}
1951
1952#
1953# Check for kchmviewer, needed to display the online help
1954# (unused as we ship kchmviewer)
1955#
1956check_kchmviewer()
1957{
1958 test_header kchmviewer
1959 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1960 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1961 if [ $? -ne 0 ]; then
1962 log_failure "kchmviewer not working"
1963 fail
1964 else
1965 log_success "found version $kchmviewer_ver"
1966 fi
1967 fi
1968}
1969
1970
1971#
1972# Check for the kBuild tools, we don't support GNU make
1973#
1974check_kbuild()
1975{
1976 test_header kBuild
1977 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1978 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1979 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1980 echo "export PATH_KBUILD" >> $ENV
1981 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1982 echo "export PATH_DEVTOOLS" >> $ENV
1983 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1984 echo "export PATH_KBUILD_BIN" >> $ENV
1985 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1986 if [ "$OS" = "solaris" ]; then
1987 # Because of sh being non-default shell in Solaris we need to export PATH again when
1988 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1989 echo "PATH=\"$ORGPATH\"" >> $ENV
1990 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1991 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1992 else
1993 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1994 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1995 fi
1996 echo "export PATH" >> $ENV
1997 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1998 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1999 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
2000 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
2001 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
2002 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
2003 echo "export PATH_KBUILD" >> $ENV
2004 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
2005 echo "export PATH_DEVTOOLS" >> $ENV
2006 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
2007 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
2008 echo "export PATH_KBUILD_BIN" >> $ENV
2009 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
2010 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
2011 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
2012 echo "export PATH" >> $ENV
2013 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
2014 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
2015 elif check_avail "kmk" KBUILDDIR really; then
2016 # check for installed kBuild
2017 KBUILD_SED="`which_wrapper kmk_sed`"
2018 else
2019 fail
2020 fi
2021 log_success "found"
2022}
2023
2024
2025#
2026# Check for compiler.h
2027# Some Linux distributions include "compiler.h" in their libc linux
2028# headers package, some don't. Most don't need it, building might (!)
2029# not succeed on openSUSE without it.
2030#
2031# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
2032#
2033check_compiler_h()
2034{
2035 test_header compiler.h
2036 if test ! -f "/usr/include/linux/compiler.h"; then
2037 log_success "compiler.h not found"
2038 else
2039 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
2040 log_success "compiler.h found"
2041 fi
2042}
2043
2044#
2045# Check for libcap.
2046# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
2047# sockets for doing ICMP requests.
2048#
2049check_libcap()
2050{
2051 test_header "libcap library"
2052 cat > $ODIR.tmp_src.cc << EOF
2053#include <cstdio>
2054#include <sys/types.h>
2055#include <linux/types.h>
2056#include <sys/capability.h>
2057
2058extern "C" int main(void)
2059{
2060 char buf[1024];
2061 cap_t caps = cap_get_proc();
2062 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
2063 return 0;
2064}
2065EOF
2066 if test_compile $LIBCAP libcap libcap; then
2067 if test_execute; then
2068 log_success "found"
2069 fi
2070 fi
2071}
2072
2073#
2074# Check if we are able to build 32-bit applications (needed for the guest additions)
2075#
2076check_32bit()
2077{
2078 test_header "32-bit support"
2079 cat > $ODIR.tmp_src.c << EOF
2080#include <stdint.h>
2081int main(void)
2082{
2083 return 0;
2084}
2085EOF
2086 echo "compiling the following source file:" >> $LOG
2087 cat $ODIR.tmp_src.c >> $LOG
2088 echo "using the following command line:" >> $LOG
2089 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
2090 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
2091 if [ $? -ne 0 ]; then
2092 echo
2093 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
2094 echo " Check the file $LOG for detailed error information."
2095 fail
2096 else
2097 echo "executing the binary" >> $LOG
2098 $ODIR.tmp_out 2> $ODIR.test_execute.log
2099 rc=$?
2100 cat $ODIR.test_execute.log >> $LOG
2101 if [ $rc -ne 0 ]; then
2102 echo
2103 echo " Cannot execute 32-bit applications! Either enable 32-bit support in the"
2104 echo " kernel configuration or use --disable-vmmraw to disable 32-bit guests."
2105 fail
2106 return 1
2107 fi
2108 fi
2109 log_success ""
2110}
2111
2112
2113#
2114# Check for Python
2115#
2116check_python()
2117{
2118 test_header "Python support"
2119
2120 # On darwin this is a on/off decision only
2121 if [ "$OS" = "darwin" ]; then
2122 echo "enabled"
2123 cnf_append "VBOX_WITH_PYTHON" "1"
2124 return
2125 fi
2126
2127 cat > $ODIR.tmp_src.cc << EOF
2128#include <cstdio>
2129#include <Python.h>
2130extern "C" int main(void)
2131{
2132 Py_Initialize();
2133 printf("found version %s", PY_VERSION);
2134#if PY_VERSION_HEX >= 0x02060000
2135 printf(", OK.\n");
2136 return 0;
2137#else
2138 printf(", expected version 2.6 or higher\n");
2139 return 1;
2140#endif
2141}
2142EOF
2143 found=
2144 SUPPYTHONLIBS="python2.7 python2.6 python3.1 python3.2 python3.3 python3.4 python3.4m python3.5 python3.5m"
2145 for p in $PYTHONDIR; do
2146 for d in $SUPPYTHONLIBS; do
2147 for b in lib/x86_64-linux-gnu lib/i386-linux-gnu lib64 lib/64 lib; do
2148 echo "compiling the following source file:" >> $LOG
2149 cat $ODIR.tmp_src.cc >> $LOG
2150 echo "using the following command line:" >> $LOG
2151 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
2152 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
2153 if [ $? -eq 0 ]; then
2154 found=1
2155 break
2156 fi
2157 done
2158 if [ -n "$found" ]; then break; fi
2159 done
2160 if [ -n "$found" ]; then break; fi
2161 done
2162 if [ -n "$found" ]; then
2163 if test_execute; then
2164 cnf_append "VBOX_WITH_PYTHON" "1"
2165 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
2166 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
2167 else
2168 log_failure "Python not working"
2169 fail
2170 fi
2171 else
2172 log_failure "Python not found"
2173 fail
2174 fi
2175}
2176
2177
2178#
2179# Check for Java
2180#
2181check_java()
2182{
2183 test_header "Java support"
2184 log_success
2185}
2186
2187
2188#
2189# Setup wine
2190#
2191setup_wine()
2192{
2193 test_header "Wine support"
2194 if ! which_wrapper wine > /dev/null; then
2195 echo " wine binary not found"
2196 fail
2197 fi
2198 if ! which_wrapper wine > /dev/null; then
2199 echo " wine not found"
2200 fail
2201 fi
2202 wine_version="`wine --version`"
2203 case "`expr "$wine_version" : 'wine-\([0-9.]*\)' '>' 1.1.43`" in
2204 "0")
2205 if ! which_wrapper wineprefixcreate > /dev/null; then
2206 echo " wineprefixcreate not found"
2207 fail
2208 fi
2209 ;;
2210 *) eval "wineprefixcreate() { true ; }" ;; # now created automatically
2211 esac
2212 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
2213 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
2214 echo "export WINEPREFIX" >> $ENV
2215 rm -rf $WINEPREFIX
2216 mkdir -p $WINEPREFIX
2217 touch $WINEPREFIX/.no_prelaunch_window_flag
2218 if ! wineprefixcreate -q > /dev/null 2>&1; then
2219 echo " wineprefixcreate failed"
2220 fail
2221 fi
2222 tmp=.tmp.wine.reg
2223 rm -f $tmp
2224 echo 'REGEDIT4' > $tmp
2225 echo '' >> $tmp
2226 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
2227 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
2228 echo '' >> $tmp
2229 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
2230 echo '"itss"="native"' >> $tmp
2231 echo '' >> $tmp
2232 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
2233 echo '"itss"="native"' >> $tmp
2234 echo '' >> $tmp
2235 if ! wine regedit $tmp > /dev/null 2>&1; then
2236 rm -f $tmp
2237 echo " failed to load registry changes (path)."
2238 fail
2239 fi
2240 rm -f $tmp
2241 log_success "found"
2242}
2243
2244
2245#
2246# Check for gSOAP.
2247#
2248check_gsoap()
2249{
2250 test_header "GSOAP compiler"
2251 if [ -z "$GSOAP" -a -z "$GSOAP_IMPORT" ]; then
2252 if which_wrapper pkg-config > /dev/null; then
2253 GSOAP_CXX_LIBS=`pkg-config gsoapssl++ --libs 2>> $LOG`
2254 if [ $? -eq 0 ]; then
2255 GSOAP=`pkg-config gsoapssl++ --variable=exec_prefix`
2256 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2257 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2258 GSOAP_IMPORT="$GSOAP/include/gsoap"
2259 fi
2260 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2261 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2262 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2263 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2264 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2265 else
2266 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2267 fi
2268 cnf_append "VBOX_GSOAP_CXX_LIBS" "`strip_l "$GSOAP_CXX_LIBS"`"
2269 gsoap_version=`pkg-config gsoapssl++ --modversion`
2270 log_success "found version $gsoap_version"
2271 return
2272 fi
2273 fi
2274 fi
2275 if [ -z "$GSOAP" ]; then
2276 GSOAP="/usr"
2277 fi
2278 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
2279 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
2280 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
2281 # TODO: Check for libgsoap++.a/so
2282
2283 if [ -z "$GSOAP_IMPORT" ]; then
2284 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2285 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2286 GSOAP_IMPORT="$GSOAP/include/gsoap"
2287 fi
2288 fi
2289 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
2290 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2291 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2292 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2293 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2294 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2295 else
2296 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2297 fi
2298 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoapssl++"
2299 log_success "found"
2300 else
2301 log_failure "stlvector.h not found -- disabling webservice"
2302 cnf_append "VBOX_WITH_WEBSERVICES" ""
2303 fi
2304 else
2305 log_failure "stdsoap2.h not found -- disabling webservice"
2306 cnf_append "VBOX_WITH_WEBSERVICES" ""
2307 fi
2308 else
2309 log_failure "wsdl2h not found -- disabling webservice"
2310 cnf_append "VBOX_WITH_WEBSERVICES" ""
2311 fi
2312 else
2313 log_failure "soapcpp2 not found -- disabling webservice"
2314 cnf_append "VBOX_WITH_WEBSERVICES" ""
2315 fi
2316}
2317
2318
2319#
2320# Check Xcode path
2321#
2322check_xcode_sdk_path()
2323{
2324 # Check if WITH_XCODE_DIR is set.
2325 if [ -z "$WITH_XCODE_DIR" ]; then
2326 echo "Please specify --with-xcode-dir option."
2327 return 0
2328 fi
2329
2330 # Check if specified path exists and is a directory.
2331 if [ -d "$1" ]; then
2332 return 1
2333 else
2334 echo "Xcode path [$1] not found."
2335 return 0
2336 fi
2337}
2338
2339#
2340# Determines the Darwin version.
2341# @todo This should really check the Xcode/SDK version.
2342#
2343check_darwinversion()
2344{
2345 test_header "Darwin version"
2346 darwin_ver=`uname -r`
2347 case "$darwin_ver" in
2348 15\.*)
2349 check_xcode_sdk_path "$WITH_XCODE_DIR"
2350 [ $? -eq 1 ] || fail
2351 darwin_ver="10.11" # El Capitan
2352 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2353 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2354 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2355 ;;
2356 14\.*)
2357 check_xcode_sdk_path "$WITH_XCODE_DIR"
2358 [ $? -eq 1 ] || fail
2359 darwin_ver="10.10" # Yosemite
2360 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2361 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2362 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2363 ;;
2364 13\.*)
2365 check_xcode_sdk_path "$WITH_XCODE_DIR"
2366 [ $? -eq 1 ] || fail
2367 darwin_ver="10.9" # Mavericks
2368 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2369 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2370 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2371 ;;
2372 12\.*)
2373 darwin_ver="10.8" # Mountain Lion
2374 if [ ! -z "$WITH_XCODE_DIR" ]; then
2375 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2376 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2377 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2378 else
2379 sdk=/Developer/SDKs/MacOSX10.6.sdk
2380 fi
2381 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2382 ;;
2383 11\.*)
2384 darwin_ver="10.7" # Lion
2385 sdk=/Developer/SDKs/MacOSX10.6.sdk
2386 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2387 ;;
2388 10\.*)
2389 darwin_ver="10.6" # Snow Leopard
2390 if [ "$BUILD_MACHINE" = "x86" ]; then
2391 sdk=/Developer/SDKs/MacOSX10.5.sdk
2392 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2393 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2394 else
2395 sdk=/Developer/SDKs/MacOSX10.6.sdk
2396 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2397 fi
2398# test "$CC" = "gcc" && CC="gcc-4.0"
2399# test "$CXX" = "g++" && CXX="g++-4.0"
2400 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2401 ;;
2402 9\.*)
2403 darwin_ver="10.5" # Leopard
2404 sdk=/Developer/SDKs/MacOSX10.5.sdk
2405 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2406# test "$CC" = "gcc" && CC="gcc-4.0"
2407# test "$CXX" = "g++" && CXX="g++-4.0"
2408 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2409 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2410 ;;
2411 8\.*)
2412 darwin_ver="10.4" # Tiger
2413 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2414 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2415# test "$CC" = "gcc" && CC="gcc-4.0"
2416# test "$CXX" = "g++" && CXX="g++-4.0"
2417 cnf_append "VBOX_WITH_COCOA_QT" ""
2418 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2419 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2420 ;;
2421 *)
2422 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2423 fail
2424 darwin_ver="unknown"
2425 ;;
2426 esac
2427 log_success "found version $darwin_ver (SDK: $sdk)"
2428}
2429
2430
2431check_makeself()
2432{
2433 test_header "makeself"
2434 if check_avail "$MAKESELF" makeself; then
2435 makeself_ver=`$MAKESELF --version|grep version|sed 's+^Makeself.*version \([0-9\.]*\).*+\1+'`
2436 if [ $? -ne 0 ]; then
2437 log_failure "makeself not working"
2438 fail
2439 else
2440 log_success "found version $makeself_ver"
2441 cnf_append "VBOX_MAKESELF" "`which_wrapper $MAKESELF`"
2442 fi
2443 fi
2444}
2445
2446
2447#
2448# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
2449# is around to prevent confusion when the build fails in src/recompiler.
2450# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
2451#
2452check_i386elfgcc()
2453{
2454 test_header "i386-elf-gcc"
2455 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
2456 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
2457 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
2458 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
2459 if test -z "$i386_elf_gcc"; then
2460 echo " failed to find i386-elf-gcc"
2461 fail
2462 fi
2463 log_success "found $i386_elf_gcc"
2464}
2465
2466
2467#
2468# Show help
2469#
2470show_help()
2471{
2472cat << EOF
2473Usage: ./configure [OPTIONS]...
2474
2475Configuration:
2476 -h, --help display this help and exit
2477 --nofatal don't abort on errors
2478EOF
2479[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2480[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2481[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2482[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2483[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2484[ $WITH_QT4 -eq 1 ] && echo " --disable-qt disable Qt detection"
2485[ $WITH_QT5 -eq 1 ] && echo " --disable-qt disable Qt detection"
2486[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2487[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2488[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2489[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2490[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2491[ $WITH_QT4 -eq 0 ] && echo " --enable-qt4 enable Qt4 detection"
2492[ $WITH_QT5 -eq 0 ] && echo " --enable-qt5 enable Qt5 detection"
2493[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2494[ $OSE -eq 1 ] && echo " --enable-vnc enable the VNC server"
2495[ $OSE -eq 0 ] && echo " --disable-extpack don't build the extpack"
2496[ $WITH_DOCS -eq 1 ] && echo " --disable-docs don't build the documentation"
2497[ $WITH_LIBVPX -eq 1 ] && echo " --disable-libvpx don't use libvpx for video capturing"
2498[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2499cat << EOF
2500 --disable-udptunnel disable UDP tunnel networking
2501 --disable-devmapper disable device mapper library access
2502 --disable-hardening don't be strict about /dev/vboxdrv access
2503 --build-libxml2 build libxml2 from sources
2504EOF
2505[ $OSE -eq 0 ] && cat << EOF
2506 --build-libssl build openssl from sources
2507 --build-libcurl build libcurl from sources
2508 --build-libvpx build libvpx from sources
2509EOF
2510[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2511cat << EOF
2512 --only-additions only build the Guest Additions
2513
2514Paths:
2515 --with-gcc=PATH location of the gcc compiler [$CC]
2516 --with-g++=PATH location of the g++ compiler [$CXX]
2517 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2518 --with-iasl=PATH location of the iasl compiler [$IASL]
2519 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
2520 --with-makeself=PATH location of makeself [$MAKESELF]
2521EOF
2522[ "$OS" = "darwin" ] && echo " --with-xcode-dir=DIR custom path to Xcode root directory; it is assumed that Xcode"
2523[ "$OS" = "darwin" ] && echo " contains OS X 10.6 SDK (required for Mountain Lion and newer hosts"
2524[ "$OS" = "darwin" ] && echo " only, ignored for the rest)"
2525[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2526[ $WITH_QT4 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt headers/libraries [pkgconfig]"
2527[ $WITH_QT5 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt headers/libraries [pkgconfig]"
2528[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2529[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2530[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2531cat << EOF
2532 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2533 --with-ow-dir=DIR directory where Open Watcom can be found [$WATCOM]
2534 --out-path=PATH the folder to which configuration and build output
2535 should go
2536
2537Build type:
2538 -d, --build-debug build with debugging symbols and assertions
2539 --build-profile build with profiling support
2540 --build-headless build headless (without any GUI frontend)
2541EOF
2542 exit 0
2543}
2544
2545
2546#
2547# The body.
2548#
2549
2550# test if we are OSE
2551if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/RDP/server/server.cpp" ]; then
2552 OSE=0
2553 # Set this as a reminder to print a log message once we know the path of the
2554 # log file
2555 NOT_OSE=1
2556fi
2557
2558# Change OS specific defaults; must be before all other stuff
2559if [ "$OS" = "darwin" ]; then
2560 WITH_SDL=0
2561 WITH_SDL_TTF=0
2562 WITH_X11=0
2563 WITH_ALSA=0
2564 WITH_PULSE=0
2565 WITH_DBUS=0
2566 WITH_KMODS=0
2567 BUILD_LIBXML2=1
2568 BUILD_LIBVPX=1
2569 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2570 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2571 WITH_XCODE_DIR=""
2572elif [ "$OS" = "haiku" ]; then
2573 #WITH_SDL=0
2574 WITH_SDL_TTF=0
2575 WITH_X11=0
2576 WITH_ALSA=0
2577 WITH_PULSE=0
2578 WITH_DBUS=0
2579 WITH_KMODS=0
2580 WITH_LIBIDL=0
2581 WITH_XPCOM=0
2582 BUILD_LIBXSLT=1
2583 BUILD_LIBXML2=1
2584 WITH_LIBVPX=0
2585 # it is part of libroot, which is linked by default,
2586 # but the script wants something
2587 LIBPTHREAD="-lroot"
2588 #[ $OSE -eq 1 ] || BUILD_LIBCURL=1
2589 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2590elif [ "$OS" = "solaris" ]; then
2591 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2592fi
2593
2594# scan command line options
2595for option in "$@"; do
2596 case "$option" in
2597 --help|-help|-h)
2598 show_help
2599 ;;
2600 --nofatal)
2601 nofatal=1
2602 ;;
2603 --env-only)
2604 ENV_ONLY=1
2605 ;;
2606 --with-gcc=*)
2607 CC=`echo $option | cut -d'=' -f2`
2608 ;;
2609 --with-g++=*)
2610 CXX=`echo $option | cut -d'=' -f2`
2611 ;;
2612 --with-kbuild=*)
2613 KBUILDDIR=`echo $option | cut -d'=' -f2`
2614 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2615 echo "Error: KBUILDDIR contains invalid characters!"
2616 exit 1
2617 fi
2618 ;;
2619 --with-qt-dir=*)
2620 [ $WITH_QT4 -eq 1 ] && QT4DIR=`echo $option | cut -d'=' -f2`
2621 [ $WITH_QT4 -eq 1 ] && QT4DIR_PKGCONFIG=0
2622 [ $WITH_QT5 -eq 1 ] && QT5DIR=`echo $option | cut -d'=' -f2`
2623 [ $WITH_QT5 -eq 1 ] && QT5DIR_PKGCONFIG=0
2624 ;;
2625 --with-openssl-dir=*)
2626 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2627 INCCRYPTO="-I${OPENSSLDIR}/include"
2628 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a ${OPENSSLDIR}/lib/libssl.a"
2629 ;;
2630 --with-ow-dir=*)
2631 WATCOM=`echo $option | cut -d'=' -f2`
2632 ;;
2633 --with-gsoap-dir=*)
2634 GSOAP=`echo $option | cut -d'=' -f2`
2635 ;;
2636 --with-gsoap-import=*)
2637 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2638 ;;
2639 --with-iasl=*)
2640 IASL=`echo $option | cut -d'=' -f2`
2641 ;;
2642 --with-xcode-dir=*)
2643 WITH_XCODE_DIR=`echo $option | cut -d'=' -f2`
2644 echo $option
2645 ;;
2646 --with-linux=*)
2647 LINUX=`echo $option | cut -d'=' -f2`
2648 ;;
2649 --with-mkisofs=*)
2650 MKISOFS=`echo $option | cut -d'=' -f2`
2651 ;;
2652 --with-makeself=*)
2653 MAKESELF=`echo $option | cut -d'=' -f2`
2654 ;;
2655 --target-arch=*)
2656 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2657 ;;
2658 --disable-xpcom)
2659 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2660 ;;
2661 --disable-python)
2662 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2663 ;;
2664 --disable-java)
2665 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2666 ;;
2667 --disable-vmmraw)
2668 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2669 ;;
2670 --disable-sdl-ttf)
2671 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2672 ;;
2673 --disable-qt)
2674 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2675 [ $WITH_QT5 -eq 1 ] && WITH_QT5=0
2676 ;;
2677 --enable-qt4)
2678 [ $WITH_QT4 -eq 0 ] && WITH_QT4=1
2679 [ $WITH_QT5 -eq 1 ] && WITH_QT5=0
2680 ;;
2681 --enable-qt5)
2682 [ $WITH_QT5 -eq 0 ] && WITH_QT5=1
2683 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2684 ;;
2685 --passive-mesa)
2686 PASSIVE_MESA=1
2687 ;;
2688 --disable-alsa)
2689 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2690 ;;
2691 --disable-pulse)
2692 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2693 ;;
2694 --enable-pulse)
2695 WITH_PULSE=2
2696 ;;
2697 --disable-dbus)
2698 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2699 ;;
2700 --disable-kmods)
2701 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2702 ;;
2703 --disable-opengl)
2704 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2705 ;;
2706 --enable-webservice)
2707 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2708 ;;
2709 --enable-vnc)
2710 WITH_VNC=1
2711 ;;
2712 --disable-hardening)
2713 WITH_HARDENING=0
2714 ;;
2715 --disable-extpack)
2716 WITH_EXTPACK=0
2717 ;;
2718 --disable-docs)
2719 WITH_DOCS=0
2720 ;;
2721 --enable-hardening)
2722 WITH_HARDENING=2
2723 ;;
2724 --disable-udptunnel)
2725 WITH_UDPTUNNEL=0
2726 ;;
2727 --enable-vde)
2728 WITH_VDE=1
2729 ;;
2730 --disable-devmapper)
2731 WITH_DEVMAPPER=0
2732 ;;
2733 --disable-libvpx)
2734 WITH_LIBVPX=0
2735 ;;
2736 --disable-sdl)
2737 WITH_SDL=0
2738 ;;
2739 --build-debug|-d)
2740 BUILD_TYPE=debug
2741 ;;
2742 --build-profile)
2743 BUILD_TYPE=profile
2744 ;;
2745 --build-libxml2)
2746 BUILD_LIBXML2=1
2747 ;;
2748 --build-libssl)
2749 BUILD_LIBSSL=1
2750 ;;
2751 --build-libcurl)
2752 BUILD_LIBCURL=1
2753 ;;
2754 --build-libvpx)
2755 BUILD_LIBVPX=1
2756 ;;
2757 --build-headless)
2758 HEADLESS=1
2759 WITH_SDL=0
2760 WITH_SDL_TTF=0
2761 WITH_X11=0
2762 WITH_OPENGL=0
2763 WITH_QT4=0
2764 WITH_QT5=0
2765 ;;
2766 --ose)
2767 OSE=2
2768 ;;
2769 --odir=*)
2770 ODIR="`echo $option | cut -d'=' -f2`/"
2771 ODIR_OVERRIDE=1
2772 ;;
2773 --out-path=*)
2774 out_path="`echo $option | cut -d'=' -f2`/"
2775 if [ -d $out_path ]; then
2776 saved_path="`pwd`"
2777 cd $out_path
2778 OUT_PATH="`pwd`"
2779 cd $saved_path
2780 OUT_PATH_OVERRIDE=1
2781 if [ $ODIR_OVERRIDE -eq 0 ]; then
2782 # This variable has not *yet* been overridden. That can still happen.
2783 ODIR=$OUT_PATH/
2784 fi
2785 else
2786 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2787 exit 1
2788 fi
2789 ;;
2790 --setup-wine)
2791 [ "$OS" != "darwin" ] && SETUP_WINE=1
2792 ;;
2793 --only-additions)
2794 ONLY_ADDITIONS=1
2795 ;;
2796 *)
2797 echo
2798 echo "Unrecognized option \"$option\""
2799 echo
2800 show_help
2801 ;;
2802 esac
2803done
2804
2805LOG="$ODIR$LOG"
2806ENV="$ODIR$ENV"
2807CNF="$ODIR$CNF"
2808
2809# initialize output files
2810cat > $LOG << EOF
2811# Log file generated by
2812#
2813# '$0 $*'
2814#
2815
2816EOF
2817cat > $CNF << EOF
2818# -*- Makefile -*-
2819#
2820# automatically generated by
2821#
2822# '$0 $*'
2823#
2824# It will be completely overwritten if configure is executed again.
2825#
2826
2827EOF
2828cat > $ENV << EOF
2829#!/bin/bash
2830#
2831# automatically generated by
2832#
2833# '$0 $*'
2834#
2835# It will be completely overwritten if configure is executed again.
2836# Make sure you source this file once before you start to build VBox.
2837#
2838
2839EOF
2840
2841# Print log warning about OSE if necessary
2842if [ -n "$NOT_OSE" ]; then
2843 echo "Found RDP server, assuming VBOX_OSE = FALSE" >> $LOG
2844 echo >> $LOG
2845fi
2846
2847
2848if [ "$BUILD_TYPE" = "debug" ]; then
2849 echo "Creating DEBUG build!" >> $LOG
2850elif [ "$BUILD_TYPE" = "profile" ]; then
2851 echo "Creating PROFILE build!" >> $LOG
2852fi
2853
2854# first determine our environment
2855check_environment
2856check_kbuild
2857
2858[ -n "$ENV_ONLY" ] && exit 0
2859
2860# append the tools directory to the default search path
2861echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2862export PATH
2863
2864# if we will be writing to a different out directory then set this up now
2865if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2866 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2867 echo "export AUTOCFG" >> $ENV
2868 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2869 echo "export LOCALCFG" >> $ENV
2870 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2871 echo "export PATH_OUT_BASE" >> $ENV
2872fi
2873
2874# don't bother people with -Werror
2875cnf_append "VBOX_GCC_WERR" "\$(NO_SUCH_VARIABLE)"
2876
2877# some things are not available in for OSE
2878if [ $OSE -ge 1 ]; then
2879 cnf_append "VBOX_OSE" "1"
2880 cnf_append "VBOX_WITH_VALIDATIONKIT" ""
2881 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2882
2883 if [ "$OS" = "linux" ]; then
2884 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2885 else
2886 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2887 fi
2888 echo >> $CNF
2889fi
2890
2891# extpack
2892if [ $ONLY_ADDITIONS -eq 1 ]; then
2893 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2894elif [ $OSE -eq 0 ]; then
2895 if [ $WITH_EXTPACK -eq 1 ]; then
2896 BUILD_LIBSSL=1
2897 else
2898 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2899 fi
2900fi
2901
2902# headless
2903if [ -n "$HEADLESS" ]; then
2904 cnf_append "VBOX_HEADLESS" "1"
2905fi
2906
2907# emit disable directives corresponding to any --disable-xxx options.
2908if [ $WITH_OPENGL -eq 0 ]; then
2909 cnf_append "VBOX_WITH_CROGL" ""
2910 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2911 cnf_append "VBOX_GUI_USE_QGL" ""
2912fi
2913[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2914[ $WITH_QT4 -eq 0 -a $WITH_QT5 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2915[ $WITH_QT5 -eq 1 ] && cnf_append "VBOX_WITH_QTGUI_V5" "1"
2916[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2917[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2918[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2919[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JWS" ""
2920[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2921[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2922[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2923if [ $WITH_LIBVPX -eq 0 ]; then
2924 cnf_append "VBOX_WITH_LIBVPX" ""
2925 cnf_append "VBOX_WITH_VIDEOREC" ""
2926fi
2927
2928# Darwin-specific
2929if [ "$OS" = "darwin" ]; then
2930 check_darwinversion
2931fi
2932# the tools
2933check_gcc
2934if [ $ONLY_ADDITIONS -eq 0 ]; then
2935 check_open_watcom
2936 [ "$OS" != "darwin" ] && check_iasl
2937 # don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2938 # [ "$OS" != "darwin" ] && check_yasm
2939 [ "$OS" != "darwin" ] && check_xsltproc
2940 [ "$OS" != "darwin" ] && check_mkisofs
2941fi
2942
2943# the libraries
2944if [ $ONLY_ADDITIONS -eq 0 ]; then
2945 [ "$OS" != "darwin" ] && check_pthread
2946 check_libxml2
2947 [ $WITH_LIBIDL -eq 1 ] && check_libidl
2948 check_ssl
2949 check_curl
2950 [ $WITH_LIBVPX -eq 1 ] && check_vpx
2951 [ "$OS" != "darwin" ] && check_z
2952 [ "$OS" != "darwin" ] && check_png
2953 [ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2954 if [ $WITH_SDL -eq 1 ]; then
2955 check_sdl
2956 else
2957 cnf_append "VBOX_WITH_VBOXSDL" ""
2958 fi
2959 [ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2960 [ $WITH_X11 -eq 1 ] && check_x
2961 # TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2962 # TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2963 [ $WITH_X11 -eq 1 ] && check_xcursor
2964 [ $WITH_X11 -eq 1 ] && check_xinerama
2965 [ $WITH_X11 -eq 1 ] && check_xrandr
2966 [ $WITH_OPENGL -eq 1 ] && check_opengl
2967 [ $WITH_QT4 -eq 1 ] && check_qt4
2968 [ $WITH_QT5 -eq 1 ] && check_qt5
2969 [ $WITH_PYTHON -eq 1 ] && check_python
2970 [ $WITH_JAVA -eq 1 ] && check_java
2971
2972 # PulseAudio
2973 if [ "$OS" = "linux" -o "$OS" = "freebsd" -o "$OS" = "netbsd" ]; then
2974 if [ $WITH_PULSE -eq 1 ]; then
2975 check_pulse
2976 elif [ $WITH_PULSE -eq 0 ]; then
2977 cnf_append "VBOX_WITH_AUDIO_PULSE" ""
2978 fi
2979 fi
2980fi
2981
2982# Linux-specific
2983if [ "$OS" = "linux" ]; then
2984 # don't check for the static libstdc++ in the PUEL version as we build the
2985 # additions at a dedicated box
2986 [ $OSE -ge 1 ] && check_staticlibstdcxx
2987 if [ $WITH_KMODS -eq 1 ]; then
2988 check_linux
2989 else
2990 cnf_append "VBOX_LINUX_SRC" ""
2991 cnf_append "VBOX_WITH_VBOXDRV" ""
2992 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2993 fi
2994 if [ $ONLY_ADDITIONS -eq 0 ]; then
2995 if [ $WITH_ALSA -eq 1 ]; then
2996 check_alsa
2997 else
2998 cnf_append "VBOX_WITH_AUDIO_ALSA" ""
2999 fi
3000 if [ $WITH_DBUS -eq 0 ]; then
3001 cnf_append "VBOX_WITH_DBUS" ""
3002 fi
3003 if [ $WITH_DEVMAPPER -eq 1 ]; then
3004 check_libdevmapper
3005 else
3006 cnf_append "VBOX_WITH_DEVMAPPER" ""
3007 fi
3008 check_libcap
3009 fi
3010 check_compiler_h
3011 [ $ONLY_ADDITIONS -eq 0 -a "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
3012 # tools/common/makeself*
3013 [ $OSE -ge 1 ] && check_makeself
3014fi
3015
3016[ -n "$SETUP_WINE" ] && setup_wine
3017
3018if [ $ONLY_ADDITIONS -eq 0 -a $WITH_GSOAP -eq 1 ]; then
3019 check_gsoap
3020else
3021 if [ $OSE -ge 1 ]; then
3022 cnf_append "VBOX_WITH_WEBSERVICES" ""
3023 fi
3024fi
3025
3026# UDPTUNNEL
3027if [ $ONLY_ADDITIONS -eq 0 -a $WITH_UDPTUNNEL -eq 0 ]; then
3028 cnf_append "VBOX_WITH_UDPTUNNEL" ""
3029fi
3030
3031# VDE
3032if [ $ONLY_ADDITIONS -eq 0 -a "$OS" = "linux" -o "$OS" = "freebsd" ]; then
3033 if [ $WITH_VDE -eq 1 ]; then
3034 cnf_append "VBOX_WITH_VDE" "1"
3035 fi
3036fi
3037
3038# DOCS
3039if [ $ONLY_ADDITIONS -eq 1 -o $WITH_DOCS -eq 0 ]; then
3040 cnf_append "VBOX_WITH_DOCS" ""
3041 cnf_append "VBOX_WITH_DOCS_PACKING" ""
3042fi
3043
3044# VNC server support
3045if [ $ONLY_ADDITIONS -eq 0 -a $OSE -ge 1 ]; then
3046 if [ $WITH_VNC = 1 ]; then
3047 check_vncserver
3048 else
3049 cnf_append "VBOX_WITH_EXTPACK_VNC" ""
3050 fi
3051fi
3052
3053if [ $ONLY_ADDITIONS -eq 1 ]; then
3054 cnf_append "VBOX_ONLY_ADDITIONS" "1"
3055fi
3056
3057# success!
3058echo
3059echo "Successfully generated '$CNF' and '$ENV'."
3060echo "Source '$ENV' once before you start to build VBox:"
3061echo ""
3062echo " source $ENV"
3063echo " kmk"
3064echo ""
3065if [ "$OS" = "linux" ]; then
3066 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
3067 vbox_out_path=$OUT_PATH
3068 else
3069 vbox_out_path=./out
3070 fi
3071 echo "To compile the kernel modules, do:"
3072 echo ""
3073 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
3074 echo " make"
3075 echo ""
3076fi
3077if [ $ONLY_ADDITIONS -eq 1 ]; then
3078 echo ""
3079 echo " Tree configured to build only the Guest Additions"
3080 echo ""
3081elif [ $WITH_HARDENING -gt 0 ]; then
3082 echo ""
3083 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
3084 echo " Hardening is enabled which means that the VBox binaries will not run from"
3085 echo " the binary directory. The binaries have to be installed suid root and some"
3086 echo " more prerequisites have to be fulfilled which is normally done by installing"
3087 echo " the final package. For development, the hardening feature can be disabled"
3088 echo " by specifying the --disable-hardening parameter. Please never disable that"
3089 echo " feature for the final distribution!"
3090 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
3091 echo ""
3092else
3093 echo ""
3094 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
3095 echo " Hardening is disabled. Please do NOT build packages for distribution with"
3096 echo " disabled hardening!"
3097 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
3098 echo ""
3099fi
3100echo "Enjoy!"
3101cleanup
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette